<?php
 /*
* @package   JE Guestbook
* @copyright Copyright (C) 2009 - 2010 Open Source Matters. All rights reserved.
* @license   http://www.gnu.org/licenses/lgpl.html GNU/LGPL, see LICENSE.php
* Contact to : emailtohardik@gmail.com, joomextensions@gmail.com
* Visit : http://www.joomlaextensions.co.in/
**/ 
defined ('_JEXEC') or die ('Restricted access');
 
jimport('joomla.application.component.model');

class item_detailModelitem_detail extends JModel
{
	var $_data = null;
	var $_total = null;
	var $_pagination = null;
	var $_table_prefix = null;
	
	function __construct()
	{
		parent::__construct();
		global $mainframe, $context; 
		$context='itemid';
	  	$this->_table_prefix = '#__je_';
	}
	
	function getPagination()
	{
		if (empty($this->_pagination))
		{
			jimport('joomla.html.pagination');
			$this->_pagination = new JPagination( $this->getrating_page(), JRequest::getVar( 'limitstart', 0 ), 5 );
			
			
		}

		return $this->_pagination;
	}
  	
	// ===================================== Functions for Ratings =============================================================
	
	function drawStars($id,$itemid) {
		
		
		if (!is_numeric($id)) {
			trigger_error("RatingManager encountered problem in drawStars() parameter. Passed parameter must be numeric.");
			exit;
		}	
		$this->id = $id;
		$allowVote = true;
		$ipAddress	= $_SERVER['REMOTE_ADDR'];
		return $this->drawPrintedStars(true, $allowVote,$itemid);
	}
	
	
	function updateVote($numberofVotesReceived,$itemid) {
	
		$db= & JFactory :: getDBO();
		$user = clone(JFactory::getUser());
		$userid = $user->id;
		$result = $this->getRatingById();
		$total = count((array)$result);
		$ipAddress = $_SERVER['REMOTE_ADDR'];
		$query = "INSERT INTO ".$this->_table_prefix."guestratings (id, total_value, used_ips,userid,itemid,ratcomment) 
					 VALUES ('', ".$numberofVotesReceived.", '".$ipAddress."',".$userid.",".$itemid.",'".$ratcomment."')";			
		$db->setQuery($query);
		$db->query();
		return $this->drawPrintedStars(false, false,$itemid); exit;
	}
	
	function getRatingById() {
		$user = clone(JFactory::getUser());
		$userid = $user->id;
		$db= & JFactory :: getDBO();
		$query = "SELECT * FROM ".$this->_table_prefix."guestratings ";
		$db->setQuery($query);
		return $db->loadObjectlist();
	}
	
	
	function drawPrintedStars($addWrapperDiv = false, $allowVote = false,$itemid) {
		
		$TOTALSTARS = 5;
		$STARWIDTH 	= 20;
		$currentRating = @number_format($this->totalValues / $this->totalVotes, 2)* $STARWIDTH;
		$option = JRequest::getVar('option');
		
		$uri =& JURI::getInstance();
		$url= $uri->root();
		$link = $url."components/".$option;
		
		$voteClass = ($allowVote == true)? 'allow': 'voted';
		
		$ratingString = array("<ul class=\"ratings\">");
		$ratingString[] = "<li class=\"current\" style=\"width:". $currentRating ."px;\">Currently " . $currentRating ."</li>";
		
		for ($i = 1; $i <= $TOTALSTARS; $i++) { 
			
			$url123 = $url.'index.php?option=com_jeguestbook&view=item_detail&task=updatestars&rating='.$i.'&id='.$this->id.'&itemid='.$itemid;
			$ratingString[] = "<li><a href=\"#\" title=\"{$i} out of " . $TOTALSTARS ."\" class=\"s{$i} {$voteClass}\" onclick=\"return select_vote('{$url123}', {$this->id}, '{$voteClass}',{$itemid},{$i});\">{$i}</a></li>";
			
		}
		
		$ratingString[] = "</ul>"; //show the updated value of the vote
		//name of the div id to be updated | the html that needs to be changed
		if ($addWrapperDiv === true) {
			$output = '<div id="' . $this->id. '">' . implode("",$ratingString) . '</div>';
		}
		
		return $output;
	}
	
	
	function printstar($itemid)
	{
		$option = JRequest::getVar('option');
		$uri =& JURI::getInstance();
		$url= $uri->root();
		$db= & JFactory :: getDBO();
		
		$TOTALSTARS = 5;
		$STARWIDTH 	= 20;
		
		$query = "SELECT SUM(total_value) AS total_rating,COUNT(total_value) AS rating_count FROM ".$this->_table_prefix."guestratings WHERE itemid=".$itemid;
		$db->setQuery($query);
		$ratingvalue=$db->loadObject();
		
			
		$currentRating = @number_format($ratingvalue->total_rating / $ratingvalue->rating_count, 2)* $STARWIDTH;
		
		$ratingString = array("<ul class=\"ratings\">");
		$ratingString[] = "<li class=\"current\" style=\"width:". $currentRating ."px;\"></li>
							";
		$ratingString[] = "</ul>"; //show the updated value of the vote
		$output = implode("",$ratingString);
		
		//echo $output;
		
		return $output;
		
	}
	
	
	function getrating($itemid)
	{
		$db= & JFactory :: getDBO();
		
		$start = ( JRequest::getVar( 'limitstart', 0, '', 'int' ) );
		$limit = intval(5);
		
		$query = "SELECT r.*,u.id AS user_id,u.username FROM ".$this->_table_prefix."guestratings AS r LEFT JOIN #__users AS u ON u.id=r.userid WHERE itemid=".$itemid." ORDER BY r.id ASC LIMIT $start, ".$limit;
		$db->setQuery($query);
		return $db->loadObjectlist();
	}
	
	function check_rating_user($itemid,$userid) {
		
		$db= & JFactory :: getDBO();
		$query = 'SELECT * FROM '.$this->_table_prefix.'guestratings WHERE itemid='.$itemid.' AND userid='.$userid;
		$db->setQuery($query);
		return $db->loadObject();
	}
	
	function check_ipaddress($itemid,$ipaddress) {
		
		$db= & JFactory :: getDBO();
		$query = 'SELECT * FROM '.$this->_table_prefix.'guestratings WHERE itemid='.$itemid.' AND used_ips="'.$ipaddress.'" AND userid=0';
		$db->setQuery($query);
		return $db->loadObject();
	}
	
	function getrating_page()
	{
		$itemid = JRequest::getVar('d_itemid');
		$db= & JFactory :: getDBO();
		$query = 'SELECT * FROM '.$this->_table_prefix.'guestratings WHERE itemid='.$itemid.' ORDER BY id ASC';
		return $this->_getListCount($query);
		//return $db->loadObject();
	}
	
}	

